unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, SPComm, ExtCtrls, IdAntiFreezeBase, IdAntiFreeze,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, ComCtrls,
  ScktComp, XPMan, IdIPWatch, IdUDPServer, IdUDPBase, IdSocketHandle,
  IdUDPClient;

type
  TForm1 = class(TForm)
    Shape1: TShape;
    Button1: TButton;
    ComboBox1: TComboBox;
    Comm1: TComm;
    ComboBox3: TComboBox;
    GroupBox1: TGroupBox;
    Memo1: TMemo;
    GroupBox2: TGroupBox;
    Memo2: TMemo;
    Button2: TButton;
    GroupBox3: TGroupBox;
    Memo3: TMemo;
    GroupBox4: TGroupBox;
    Memo4: TMemo;
    Button3: TButton;
    Shape2: TShape;
    Edit1: TEdit;
    Edit2: TEdit;
    Button4: TButton;
    ClientSocket1: TClientSocket;
    StatusBar1: TStatusBar;
    ServerSocket1: TServerSocket;
    XPManifest1: TXPManifest;
    ComboBox2: TComboBox;
    Button5: TButton;
    Button6: TButton;
    IdIPWatch1: TIdIPWatch;
    chk_TcpHex: TCheckBox;
    chk_ComHex: TCheckBox;
    IdUDPServer1: TIdUDPServer;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Comm1ReceiveData(Sender: TObject; Buffer: Pointer;
      BufferLength: Word);
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientSocket1Connect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Disconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Error(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ComboBox2Change(Sender: TObject);
    procedure ServerSocket1ClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ClientError(Sender: TObject;
      Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
      var ErrorCode: Integer);
    procedure Button5Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure IdUDPServer1UDPRead(Sender: TObject; AData: TStream;
      ABinding: TIdSocketHandle);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
//============================ 232 ============================
//򿪴
procedure TForm1.Button1Click(Sender: TObject);
begin
  if Button1.Caption = '򿪴' then
  begin
    try
      Comm1.CommName := ComboBox1.Text;
      Comm1.BaudRate := StrToInt(ComboBox3.Text);
      Comm1.StartComm;
      Shape1.Brush.Color := clGreen;
      Button1.Caption := 'رմ';
    except
      Application.MessageBox('δֿôڻռ', 'ʾ', MB_OK);
    end;
  end else
  begin
    Comm1.StopComm;
    Shape1.Brush.Color := clSilver;
    Button1.Caption := '򿪴';
  end;
end;
//ͺ
procedure TForm1.Button2Click(Sender: TObject);
begin
  Comm1.WriteCommData(pchar(Memo2.Text), Length(Memo2.Text)); //
end;
//պ
procedure TForm1.Comm1ReceiveData(Sender: TObject; Buffer: Pointer;
  BufferLength: Word);
var
  i: Integer;
  rbuf: array of Char;
begin
  SetLength(rbuf, BufferLength);
  move(Buffer^, rbuf[0], BufferLength);
  for i := 0 to BufferLength - 1 do
  begin
    if chk_ComHex.Checked then
      Memo1.Text := Memo1.Text + IntToHex(Ord(rbuf[i]), 2) + ' '
    else
      Memo1.Text := Memo1.Text + rbuf[i];
  end;
  Memo1.SelLength := Length(Memo1.Text); //Զ·ʾ
end;
//============================ TCP Client ============================
//
procedure TForm1.Button4Click(Sender: TObject);
begin
  case ComboBox2.ItemIndex of
    0:
      with ClientSocket1 do
      begin
        if Button4.Caption = '' then
        begin
          Active := False;
          Host := Edit1.Text; //'192.168.0.21';
          Port := StrToInt(Edit2.Text); //6006;
          Active := True;
        end else
          Active := False;
      end;
    1:
      with ServerSocket1 do
      begin
        if Button4.Caption = '' then
        begin
          Active := False;
          Port := StrToInt(Edit2.Text); ;
          Active := True;
          StatusBar1.Panels[0].Text := 'ȴ...';
        end else
        begin
          Active := False;
          Button4.Caption := '';
          Shape2.Brush.Color := clSilver;
          StatusBar1.Panels[0].Text := 'ֹͣ';
        end;
      end;
  end;
end;
//ͺ
procedure TForm1.Button3Click(Sender: TObject);
begin
  case ComboBox2.ItemIndex of
    0: ClientSocket1.Socket.SendText(Memo4.Text);
    1: ServerSocket1.Socket.Connections[0].SendText(Memo4.Text);
    2: IdUDPServer1.Send(Edit1.Text, StrToInt(Edit2.Text), Memo4.Text);
  end;
end;
//ڹر
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ClientSocket1.Close;
  ServerSocket1.Close;
end;
//
procedure TForm1.ClientSocket1Read(Sender: TObject;
  Socket: TCustomWinSocket);
var
  i: Integer;
  buf: array of Byte;
  RStr: string;
begin
  RStr := Socket.ReceiveText;
  if chk_TcpHex.Checked then
  begin
    SetLength(buf, Length(RStr));
    for i := 1 to Length(RStr) do
    begin
      buf[i - 1] := Ord(RStr[i]);
      Memo3.Text := Memo3.Text + IntToHex(buf[i - 1], 2) + ' ';
    end;
  end else
    //ӿͻ˶ȡϢӵMemo1
    Memo3.Text := Memo3.Text + RStr;
  Memo3.SelLength := Length(Memo3.Text);
end;
//Ѿӵ
procedure TForm1.ClientSocket1Connect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  Button4.Caption := 'Ͽ';
  Shape2.Brush.Color := clGreen;
  StatusBar1.Panels[0].Text := 'Ѿӵ ' + Socket.RemoteAddress;
end;
//Ͽ˵ʱ
procedure TForm1.ClientSocket1Disconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  Button4.Caption := '';
  Shape2.Brush.Color := clSilver;
  StatusBar1.Panels[0].Text := 'ѾϿ ' + Socket.RemoteAddress + ' ӡ';
end;
//˵ӷʱ
procedure TForm1.ClientSocket1Error(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  StatusBar1.Panels[0].Text := '˵ӷ';
  ErrorCode := 0;
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
  ClientSocket1.Active := False;
  ServerSocket1.Active := False;
  case ComboBox2.ItemIndex of
    0: Button4.Caption := '';
    1: Button4.Caption := '';
  end;
end;
//============  ====================
procedure TForm1.ServerSocket1ClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
  i: Integer;
  buf: array of Byte;
  RStr: string;
begin
  RStr := Socket.ReceiveText;
  if chk_TcpHex.Checked then
  begin
    SetLength(buf, Length(RStr));
    for i := 1 to Length(RStr) do
    begin
      buf[i - 1] := Ord(RStr[i]);
      Memo3.Text := Memo3.Text + IntToHex(buf[i - 1], 2) + ' ';
    end;
  end else
    //ӿͻ˶ȡϢӵMemo1
    Memo3.Text := Memo3.Text + RStr;
  Memo3.SelLength := Length(Memo3.Text);
end;

procedure TForm1.ServerSocket1ClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  Button4.Caption := 'ֹͣ';
  Shape2.Brush.Color := clGreen;
  StatusBar1.Panels[0].Text := 'Ѿͻ ' + Socket.RemoteAddress;
end;

procedure TForm1.ServerSocket1ClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  Button4.Caption := '';
  Shape2.Brush.Color := clSilver;
  StatusBar1.Panels[0].Text := 'Ͽͻӡ';
end;

procedure TForm1.ServerSocket1ClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  StatusBar1.Panels[0].Text := 'ͻ˵ӷ';
  ErrorCode := 0;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  case TButton(Sender).Tag of
    1: Memo1.Clear;
    2: Memo3.Clear;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Edit1.Text := IdIPWatch1.LocalIP;
end;

procedure TForm1.IdUDPServer1UDPRead(Sender: TObject; AData: TStream;
  ABinding: TIdSocketHandle);
  function BufToASC(buf: array of Byte): string;
  var
    n: Integer;
  begin
    Result := '';
    for n := 0 to Length(buf) - 1 do
    begin
      Result := Result + Char(buf[n]);
    end;
  end;
var
  fd: array of Byte;
  i: Integer;
begin
  try
    SetLength(fd, AData.Size);
    AData.ReadBuffer(fd[0], AData.Size);
    if chk_TcpHex.Checked then
      for i := 1 to AData.Size do
        Memo3.Text := Memo3.Text + IntToHex(fd[i - 1], 2) + ' '
    else
      Memo3.Text := Memo3.Text + BufToASC(fd); //Memo3.Text + pchar(@fd[0]);
    //Char(Ord(StrToInt('$'+s1[j*2-1]+s1[j*2])));
  except
    Exit;
  end;
end;

end.

